#include <cstdio>
using namespace std;

#define mx 4
#define base 1000000000
#define lb 9
#define type long long

struct L
{
	int ss[mx];
	L() { for (int q1=0; q1<mx; q1++) ss[q1]=0; }
	L(int a) {
		for (int q1=mx-1, c1=a; q1>=0; q1--) {
			ss[q1] = c1%base;
			c1 /= base;
		}
	}
};

int dif(const L &a, const L &b)
{
	int q1;
	for (q1=0; q1<mx; q1++) if (a.ss[q1]!=b.ss[q1]) break;
	if (q1==mx) return 0;
	return a.ss[q1]-b.ss[q1];
}

int operator< (const L &a, const L &b) { return dif(a,b)<0;  }
int operator> (const L &a, const L &b) { return dif(a,b)>0;  }
int operator==(const L &a, const L &b) { return dif(a,b)==0; }
int operator!=(const L &a, const L &b) { return dif(a,b)!=0; }
int operator<=(const L &a, const L &b) { return dif(a,b)<=0; }
int operator>=(const L &a, const L &b) { return dif(a,b)>=0; }

L operator+(const L &a, const L &b)
{
	L c;
	
	for (int q1=mx-1,c1=0; q1>=0; q1--) {
		c1 += a.ss[q1] + b.ss[q1];
		c.ss[q1] = c1%base;
		c1 /= base;
	}
  
	return c;
}

L operator-(const L &a, const L &b)
{
	L c;
	if (b>a) return b-a;

	for (int q1=mx-1, c1=0, c2=0; q1>=0; q1--) {
		c1 = a.ss[q1] - b.ss[q1] - c2;
		c2 = 0;
		if (c1<0) {
			c1 += base;
			c2=1;
		}
		c.ss[q1] = c1;
	}

	return c;
}

L operator/(const L a, int b)
{
	L c;
	for (int q1=0,c1=0; q1<mx; q1++) {
		c1 += a.ss[q1];
		c.ss[q1] = c1/b;
		c1 = (c1%b)*base;
	}

	return c;
}

int operator%(const L &a, int b)
{
	type c1=0;
	for (int q1=0; q1<mx; q1++) {
		c1 += a.ss[q1];
		c1 = (c1%(type)b)*(type)base;
	}

	return (int)(c1/(type)base);
}

L read (FILE *fn)
{
	int q1, c1, c2, q2, c3;
	char d[mx*lb];
	L c;

	fscanf(fn,"%s",d);
	for (q1=0; d[q1]; q1++) ;
	c1 = q1;
	for (q1=c1-1, c2=0, c3=mx-1; q1>=0; q1-=lb, c2=0) {
		for (q2=lb-1; q2>=0; q2--)
			if (q1-q2>=0)
				c2=c2*10+d[q1-q2]-48;
		c.ss[c3--]=c2;
	}

	return c;
}

void write(L a)
{
	int q1;
	
	for (q1=0; q1<mx&&a.ss[q1]==0; q1++) ;
	if (q1==mx) q1--;
  
	printf("%d", a.ss[q1]);
	for (q1++; q1<mx; q1++)
		printf ("%0*d",lb,a.ss[q1]);

	printf("\n");
}

int len (int p)
{
	int br;
	
	for (br=0; p!=1; br++) {
		if (p%3==0) p/=3;
		else if (!(p&1)) p>>=1;
		else p++;
	}

	return br;
}

L a, b, c(7), d(6), lo(1), up, mid, ans(0);

int main ()
{
	int i;

	a = read(stdin);
	b = read(stdin);

	if (b<=1e7) {
		int bans=a.ss[mx-1];
		for (i=bans+1; i<=b.ss[mx-1]; i++)
			if (len(i) > len(bans))
				bans=i;

		printf ("%d\n", bans);

		return 0;
	}

	while (c<=a) {
		lo = c;
		c = c+d;
		d = d+d;
	}

	while (c<=b) {
		ans = c;
		c = c+d;
		d = d+d;
	}
	up = c;

	//write (lo);
	//write (up);

	if (ans==0) {
		while (lo+1<up) {
			if (lo%2==0 || up%2==0) up=up-1;

			mid = (lo+up)/2;

			if (mid%2 && a<=mid && mid<=b) break;

			if (mid<a) lo=mid;
			else up=mid;
		}

		ans = mid;
	}

	//write (lo);
	//write (up);

	write (ans);

	/*
	int p, q, bans;
	scanf ("%d%d", &p, &q);
	bans=p;

	for (i=p+1; i<=q; i++)
		if (len(i) > len(bans)) bans=i;

	printf ("%s: %d\n", ans==bans?"YES":"ufff", bans);
	*/

	return 0;
}
