#include <iostream>
#include <algorithm>
using namespace std;

class longNum
{
    public:
    int m[6];
    longNum(){memset(m, 0, sizeof(m));}
    void incr()
    {
         int i = 0;
         while (++m[i] == 1000000) m[i] = 0, i++; 
    }  
    void decr()
    {
         int i = 0;
         while (m[i] == 0) m[i] = 999999, i++;
         m[i]--;
    }
    bool operator==(longNum p)
    {
         return m[0]==p.m[0] && m[1]==p.m[1] && 
                m[2]==p.m[2] && m[3]==p.m[3] &&
                m[4]==p.m[4] && m[5]==p.m[5];
    }
    void divide(int k)
    {
         int carry = 0;
         for (int i = 5; i >= 0; i--) m[i] = carry*1000000 + m[i],
                                      carry = m[i]%k,
                                      m[i] /= k;
    }
    bool div2()
    {
         return m[0]%2 == 0;
    }
    bool div3()
    {
         int sum = m[0]+m[1]+m[2]+m[3]+m[4]+m[5];
         return sum%3 == 0;
    }
    void print()
    {
         int i = 5;
         while (m[i] == 0) i--;
         cout << m[i];
         i--;
         
         for (; i >= 0; i--)
         {
             
             int r = 1000000;
             int l = 100000;
         
             for (int j = 0; j < 6; j++)
             { 
                 cout << (m[i]%r)/l;
                 r /= 10;
                 l /= 10;
             }
         }
         cout << endl;
    }
    bool iszero()
    {
         return !m[0] && !m[1] && !m[2] && !m[3] && !m[4] && !m[5];
    }
    bool isone()
    {
         return m[0]==1 && !m[1] && !m[2] && !m[3] && !m[4] && !m[5];
    }
};

int path(longNum N)
{
    int ret = 0;
    while (!N.isone())
    {
          if (N.div3()) N.divide(3);
          else if (N.div2()) N.divide(2);
          else N.incr();
          
          ret++;
    }
    return ret;
}

longNum makeLong(string s)
{
        longNum ret;
        for (int i = 0; i < 6; i++)
        {
            int d = 1;
            for (int j = s.size() - 1 - 6*i; j > max(-1, (int)s.size() - 1 - 6*(i+1)); j--) 
             ret.m[i] += d*(s[j]-'0'), d *= 10;
        }
        return ret;
}
int main()
{
    string S1, S2;
    cin >> S1 >> S2;
    longNum A = makeLong(S1);
    longNum B = makeLong(S2);
    
    int ans = 0;
    longNum C;
    for (int q = 0; q < 300000; q++)
    {
        int p = path(B);
        if (ans < p)
        {
             ans = p;
             C = B;
        }
        if (A == B) break;
        B.decr();
    }
    //cout << ans << " ";
    C.print();
    return 0;
}
